   
%% timestamp
fprintf(1,'Started on %s\n', datestr(now));

%% load data and create inverted file

% path to the preprocessed data
load('mpvdb_haff2.mat');

% load results
RES = load('results.mat');

opt.root_dir='mpv/images';
opt.subplot =1;
opt.ofs = 1;

RES.opt

if size(RES.query_bbx,1)>4
   RES.query_bbx = RES.query_bbx';
end;

%% your objects 
ap = 0;
for i=1:5
   if (iscell(RES.query_results(i)))
      Q = RES.query_results{i};
   else
      Q = RES.query_results(i);
   end;
   bbx = RES.query_bbx(:, i);
   showresults(Q.img_ids(1:5), Q.score, Q.A, bbx, opt, NAMES);
   good = getgt(RES.query_id(i), NAMES);
   [a b c]=evalgt(Q.img_ids, [1:numel(Q.img_ids)], good, logical(zeros(1,numel(good))));
   [p f e]=fileparts(NAMES{RES.query_id(i)});
   fprintf('Query: %-30s score: %5.3f\n', f, a);
   ap = ap + a;
end;

%% mate's objects 
for i=6:10
   if (iscell(RES.query_results(i)))
      Q = RES.query_results{i};
   else
      Q = RES.query_results(i);
   end;
   bbx = RES.query_bbx(:, i);
   showresults(Q.img_ids(1:5), Q.score, Q.A, bbx, opt, NAMES);
   good = getgt(RES.query_id(i), NAMES);
   [a b c]=evalgt(Q.img_ids, [1:numel(Q.img_ids)], good, logical(zeros(1,numel(good))));
   [p f e]=fileparts(NAMES{RES.query_id(i)});
   fprintf('Query: %-30s score: %5.3f\n', f, a);
   ap = ap + a;
end;

%% pokemons  
for i=11:15
   if (iscell(RES.query_results(i)))
      Q = RES.query_results{i};
   else
      Q = RES.query_results(i);
   end;
   bbx = RES.query_bbx(:, i);
   showresults(Q.img_ids(1:5), Q.score, Q.A, bbx, opt, NAMES);
   good = getgt(RES.query_id(i), NAMES);
   [a b c]=evalgt(Q.img_ids, [1:numel(Q.img_ids)], good, logical(zeros(1,numel(good))));
   [p f e]=fileparts(NAMES{RES.query_id(i)});
   fprintf('Query: %-30s score: %5.3f\n', f, a);
   ap = ap + a;
end;

%% UK bench dataset  
for i=16:20
   if (iscell(RES.query_results(i)))
      Q = RES.query_results{i};
   else
      Q = RES.query_results(i);
   end;
   bbx = RES.query_bbx(:, i);
   showresults(Q.img_ids(1:5), Q.score, Q.A, bbx, opt, NAMES);
   good = getgt(RES.query_id(i), NAMES);
   [a b c]=evalgt(Q.img_ids, [1:numel(Q.img_ids)], good, logical(zeros(1,numel(good))));
   [p f e]=fileparts(NAMES{RES.query_id(i)});
   fprintf('Query: %-30s score: %5.3f\n', f, a);
   ap = ap + a;
end;

%% overall result
fprintf('Average precision: %g\n', ap/20);
